﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

namespace Memcached_Ketama
{
    class Program
    {

        static Random ran = new Random();

        static void Main(string[] args)
        {

            Dictionary<string, int> hostKeyCountsDic = new Dictionary<string, int>();
            int keysNum = 50000;
            string[] hostArr = new string[] { "192.168.0.1:11211", "192.168.0.2:11211", "192.168.0.3:11211", "192.168.0.4:11211", "192.168.0.5:11211" };
            
            Console.WriteLine("每台真实Server对应虚拟节点个数都为250个");
            Console.WriteLine("随机生成的key数据为5W个");
            Console.WriteLine("平均分布的百分比应是每台:{0}%", 100.0 / hostArr.Length);
            Console.WriteLine("\r\n\r\n");

            List<string> randomKeys = new List<string>();

            #region ketama  BeitMemcached
            Console.WriteLine("-------------------------Ketama BeitMemcached版本开始------------------------");
            Stopwatch stopbeit = new Stopwatch();
            stopbeit.Start();
            KetamaVirtualNodeInit ketama = new KetamaVirtualNodeInit(hostArr);
            stopbeit.Stop();
            Console.WriteLine("BeitMemcached初始化虚拟节点耗时:{0}毫秒", stopbeit.ElapsedMilliseconds);
            Console.WriteLine("\r\n");

            for (int k = 0; k < 5; k++)
            {
                Console.WriteLine("第{0}次", k + 1);
                randomKeys = new List<string>();
                hostKeyCountsDic = new Dictionary<string, int>();
                for (int i = 0; i < keysNum; i++)
                {
                    randomKeys.Add(GenerateRandomString(ran.Next(50)));
                }

                Stopwatch watch = new Stopwatch();
                watch.Start();

                foreach (string item in randomKeys)
                {
                    string host = ketama.GetHostByHashKey(item);

                    if (hostKeyCountsDic.ContainsKey(host))
                    {
                        hostKeyCountsDic[host] = hostKeyCountsDic[host] + 1;
                    }
                    else
                    {
                        hostKeyCountsDic[host] = 1;
                    }
                }

                watch.Stop();
                Console.WriteLine("查找host共耗时{0}毫秒", watch.ElapsedMilliseconds);


                foreach (string item in hostKeyCountsDic.Keys.OrderBy(x => x))
                {
                    Console.WriteLine("Server: {0} ,存储个数 : {1} , 占百分比 : {2}%", item, hostKeyCountsDic[item], (float)hostKeyCountsDic[item] / keysNum * 100);
                }

                Console.WriteLine("\r\n\r\n");
            }
            #endregion


            #region ketama SPYMemcached
            Console.WriteLine("------------------------Ketama SPYMemcached版本开始------------------------");
            Stopwatch stopspy = new Stopwatch();
            stopspy.Start();
            KetamaNodeLocator ketamaspy = new KetamaNodeLocator(hostArr.ToList(), 250);
            stopspy.Stop();
            Console.WriteLine("SPYMemcached初始化虚拟节点耗时:{0}毫秒", stopspy.ElapsedMilliseconds);
            Console.WriteLine("\r\n");



            for (int f = 0; f < 5; f++)
            {
                Console.WriteLine("第{0}次", f + 1);
                randomKeys = new List<string>();
                hostKeyCountsDic = new Dictionary<string, int>();
                for (int i = 0; i < keysNum; i++)
                {
                    randomKeys.Add(GenerateRandomString(ran.Next(50)));
                }

                Stopwatch watch2 = new Stopwatch();
                watch2.Start();

                foreach (string item in randomKeys)
                {
                    string host = ketamaspy.GetPrimary(item);

                    if (hostKeyCountsDic.ContainsKey(host))
                    {
                        hostKeyCountsDic[host] = hostKeyCountsDic[host] + 1;
                    }
                    else
                    {
                        hostKeyCountsDic[host] = 1;
                    }
                }

                watch2.Stop();
                Console.WriteLine("查找host共耗时{0}毫秒", watch2.ElapsedMilliseconds);


                foreach (string item in hostKeyCountsDic.Keys.OrderBy(x => x))
                {
                    Console.WriteLine("Server: {0} ,存储个数 : {1} , 占百分比 : {2}%", item, hostKeyCountsDic[item], (float)hostKeyCountsDic[item] / keysNum * 100);
                }

                Console.WriteLine("\r\n\r\n");
            }

            Console.WriteLine("-----------------------测试结束-------------------------");

            #endregion



            Console.ReadLine();
        }


        /**
       * To generate the random string by the random algorithm
       * <br>
       * The char between 32 and 127 is normal char
       * 
       * @param length
       * @return
       */
        private static String GenerateRandomString(int length)
        {
            StringBuilder sb = new StringBuilder(length);

            for (int i = 0; i < length; i++)
            {
                sb.Append((char)(ran.Next(95) + 32));
            }

            return sb.ToString();
        }
    }
}
